=== Examples/Android/CMakeLists.txt ===
add_subdirectory(NativeVTK)
add_subdirectory(JavaVTK)
if (OPENGL_ES_VERSION STREQUAL "3.0")
  add_subdirectory(VolumeRender)
endif()
