=== debian/changelog ===
vtk7 (7.1.1+dfsg2-2ubuntu1) focal; urgency=medium

  * d/p/mysql8_my_bool.patch: Reintroduce my_bool to fix build with MySQL 8.
    (LP: #1863026)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 19 Feb 2020 21:46:28 +0100
