=== debian/control ===
Source: vtk7
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gert Wollny <gewo@debian.org>,
           Nico Schlömer <nico.schloemer@gmail.com>
Section: graphics
Priority: optional
Build-Depends: chrpath,
               cmake (>= 3.2.0),
               debhelper (>= 9),
               default-jdk,
               default-libmysqlclient-dev,
               dh-python,
               libftgl-dev,
               hdf5-tools,
               javahelper,
               libalglib-dev,
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev,
               libboost-all-dev,
               libdigest-md5-perl,
               libexpat-dev,
               libfreetype6-dev,
               libfontconfig1-dev,
               libgdal-dev,
               libgl1-mesa-dev | libgl-dev,
               libgl2ps-dev (>= 1.4.0),
               libglew-dev,
               libglu1-mesa-dev | libglu-dev,
               libhdf5-mpi-dev,
               libjpeg-dev,
               libjsoncpp-dev,
               libmrmpi-dev,
               libnetcdf-dev,
               libnetcdf-cxx-legacy-dev,
               libogg-dev,
               libosmesa6-dev,
               libpng-dev,
               libpq-dev,
               libproj-dev,
               libqt5opengl5-dev,
               libqt5webkit5-dev,
               libqt5x11extras5-dev,
               libsqlite3-dev,
               libswscale-dev,
               libtheora-dev,
               libtiff-dev,
               libutfcpp-dev,
               libx11-dev,
               libxml2-dev,
               libxpm-dev,
               libxt-dev,
               mpi-default-dev,
               pkg-config,
               python3-dev,
               python3-autobahn,
               python3-matplotlib,
               python3-mpi4py,
               python3-six,
               python3-twisted,
               qtbase5-dev,
               qttools5-private-dev,
               r-base,
               r-base-core,
               r-base-dev,
               tcl-dev,
               tk-dev,
               x11proto-core-dev,
               xauth,
               xvfb,
               zlib1g-dev
Build-Depends-Indep: doxygen-latex,
                     texlive-binaries,
                     graphviz,
                     ghostscript,
                     libjs-mathjax,
                     gnuplot-nox
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/science-team/vtk7
Vcs-Git: https://salsa.debian.org/science-team/vtk7.git
Homepage: http://www.vtk.org/

Package: libvtk7-dev
Architecture: any
Section: libdevel
Depends: default-libmysqlclient-dev,
         libavcodec-dev,
         libavformat-dev,
         libavutil-dev,
         libc6-dev,
         libeigen3-dev,
         libexpat-dev,
         libfreetype6-dev,
         libgdal-dev,
         libgl1-mesa-dev | libgl-dev,
         libgl2ps-dev,
         libglew-dev,
         libglu1-mesa-dev | libglu-dev,
         libhdf5-mpi-dev,
         libjpeg-dev,
         libjsoncpp-dev,
         libnetcdf-dev,
         libnetcdf-cxx-legacy-dev,
         libogg-dev,
         libpng-dev,
         libpq-dev,
         libproj-dev,
         libpython3-dev,
         libswscale-dev,
         libtheora-dev,
         libtiff-dev,
         libvtk7.1p (= ${binary:Version}),
         libvtk7-java (= ${binary:Version}),
         libx11-dev,
         libxft-dev,
         libxml2-dev,
         libxss-dev,
         libxt-dev,
         mpi-default-dev,
         python3-vtk7 (= ${binary:Version}),
         python3-zope.interface,
         tcl-dev,
         tcl-vtk7 (= ${binary:Version}),
         tk-dev,
         vtk7 (= ${binary:Version}),
         x11proto-core-dev,
         zlib1g-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: vtk7-doc,
          vtk7-examples
Conflicts: libvtk5-dev
Replaces: libvtk5-dev
Description: VTK header files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the VTK header files required to compile
 C++ programs that use VTK to do 3D visualisation.

Package: libvtk7-qt-dev
Architecture: any
Section: libdevel
Depends: libvtk7-dev (= ${binary:Version}),
         libvtk7.1p-qt (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         qtbase5-dev,
         qttools5-private-dev,
         libqt5opengl5-dev,
         libqt5webkit5-dev
Description: VTK header files, containing Qt files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the VTK header files required to compile
 C++ programs that use VTK to do 3D visualisation. Qt files

Package: libvtk7.1p
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: mpi-default-bin,
          vtk7-doc,
          vtk7-examples
Conflicts: libvtk7 (>> 6.0.0-7)
Replaces: libvtk5.8,
          libvtk7
Description: VTK libraries
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries needed to run C++ programs
 that use VTK.

Package: libvtk7.1p-qt
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: VTK libraries, Qt files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries needed to run C++ programs
 that use VTK. Qt files

Package: libvtk7-jni
Architecture: any
Section: java
Depends: ${java:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: libvtk6-jni
Replaces: libvtk6-jni
Description: Visualization Toolkit - A high level 3D visualization library - java
 The Visualization Toolkit (VTK) is an object oriented, high level
 library that allows one to easily write C++ programs, Tcl, Python and
 Java scripts that do 3D visualization.
 .
 This package provides the VTK Java language support.

Package: libvtk7-java
Architecture: any
Section: java
Depends: libvtk7-jni (= ${binary:Version}),
         ${java:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: java-virtual-machine,
          libvtk7-dev (= ${binary:Version}),
          vtk7-doc,
          vtk7-examples
Breaks: libvtk6-java
Replaces: libvtk6-java
Description: Visualization Toolkit - A high level 3D visualization library - java
 The Visualization Toolkit (VTK) is an object oriented, high level
 library that allows one to easily write C++ programs, Tcl, Python and
 Java scripts that do 3D visualization.
 .
 This package provides the VTK Java language support.

Package: python3-vtk7
Architecture: any
Section: python
Depends: libvtk7.1p (= ${binary:Version}),
         libvtk7.1p-qt (= ${binary:Version}) [!armhf !armel],
         python3-autobahn,
         python3-mpi4py,
         python3-six,
         python3-twisted,
         python3-zope.interface,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: mayavi2,
          vtk7-doc,
          vtk7-examples
Breaks: python3-vtk6
Replaces: python3-vtk6
Description: Python bindings for VTK
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the python3 bindings for VTK.

Package: tcl-vtk7
Architecture: any
Section: interpreters
Depends: libvtk7.1p (= ${binary:Version}),
         libvtk7.1p-qt (= ${binary:Version}) [!armhf !armel],
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: vtk7-doc,
          vtk7-examples
Description: Tcl bindings for VTK
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries and executable that enable 
 one to use VTK from Tcl/Tk scripts.

Package: vtk7
Architecture: any
Section: interpreters
Depends: libvtk7.1p (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: vtk7-doc,
          vtk7-examples
Description: Binaries for VTK7
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides binaries for VTK7

Package: vtk7-doc
Architecture: all
Section: doc
Depends: doc-base,
         libjs-jquery,
         libjs-mathjax,
         ${misc:Depends}
Suggests: libvtk7-dev,
          vtk7-examples
Description: VTK class reference documentation
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides documentation for VTK7

Package: vtk7-examples
Architecture: all
Section: graphics
Depends: ${misc:Depends}
Suggests: libvtk7-dev,
          python3,
          python3-vtk7,
          tcl-vtk7,
          tclsh,
          vtk7-doc
Description: VTK examples
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides examples for VTK7
