=== debian/tests/control ===
Tests: buildBoolean buildPoint buildVTU buildDistance buildPNG buildVTP
Depends: libvtk7-dev, build-essential, cmake
Restrictions: allow-stderr
